#!/usr/bin/perl -UT
use DB_File;
require './cgi-lib/cgi-lib.pl';
require './cgi-lib/wowlib.pl';
require './config/dirdata.cgi';
require './config/admininfo.cgi';

$cgi_lib'writefiles =(-e '/tmp'?'/tmp': './upload');
&ReadParse(\%in,\%cgi_cfn,\%cgi_ct,\%cgi_sfn);

$data_directory="./data/data$in{'bd'}";
$data_file="$data_directory/data.cgi";
$head_file=(-e "$data_directory/head.html" ? "$data_directory/head.html" : './config/head.html');
$cgi_lib'writefiles=0 if($cfg{'upload_dir'} eq '');
$cfg{'upload_dir'}="./$cfg{'upload_dir'}" unless("$cfg{'upload_dir'}" =~ /^\//);

$cfg_file=(-e "$data_directory/table.cgi" ? "$data_directory/table.cgi" : './config/table.cgi');
$cfg_db=tie %cfg,"DB_File",$cfg_file,O_RDONLY,0666,$DB_HASH or Err_Msg_Back("wowboard error:\\nCannot open DB file.");
require ($cfg{'language'} eq 'kr'?'./config/locale.kr':'./config/locale.en');
$cgi_lib'maxdata=$cfg{'maxdata'};

$page=($cfg{'page'}+0?$cfg{'page'}+0:15);
$table_size=$cfg{'t_num_size'}*$cfg{'t_num_show'}+$cfg{'t_dcount_size'}*$cfg{'t_dcount_show'}+$cfg{'t_title_size'}*$cfg{'t_title_show'}+$cfg{'t_count_size'}*$cfg{'t_count_show'}+$cfg{'t_date_size'}*$cfg{'t_date_show'}+$cfg{'t_name_size'}*$cfg{'t_name_show'};
umask(000);
if($in{'j'} eq 'form'){&WriteForm;
}elsif($in{'j'} eq 'dl'){&Download;
}elsif($in{'j'} eq 'write'){&DataWrite;
}elsif($in{'j'} eq 'content'){&ShowContent;
}elsif($in{'j'} eq 'reply'){&ReplyForm;
}elsif($in{'j'} eq 'fix'){&FixForm;
}elsif($in{'j'} eq 'delete'){&DeleteForm;
}elsif($in{'j'} eq 'delete_ok'){&DeleteData;
}else{$in{'j'}='';&ShowBoard;}
exit;

sub PrintHead{
	local $print_str=&PrintHeader;
	$print_str.=&ReadFilePrint($head_file);
	return "$print_str\<script languge=\"javascript\">\n<!--\nfunction enterAdmin() {\n	window.open('admin.cgi?j=login','wowboardAdmin','scrollbars=1,menubar=0,location=0,toolbar=1,resizable=1');\n}\n//-->\n</script>\n";
}

sub WriteForm{
	$td_ffffff="<td align=left width=580 bgcolor=#ffffff>";
	$td_66ccff="<tr><td align=center valign=middle width=70 bgcolor=#66ccff><font size=2>";
	$col_size=int($table_size/7);
	$font="<font face=\"gulimche,ü\">";
	print &PrintHead;
	if(($cfg{'upload_dir'} ne '')&&($cfg{'upload_dir'} ne '0')){
		$file_up_ok="$td_66ccff $msg{'file'}\n$td_ffffff<input name=\"upfile\" type=\"file\" size=32>\n";
		$enc_type="enctype=\"multipart/form-data\"";
	}

	print <<END;
<form action=$ENV{'SCRIPT_NAME'} method=POST $enc_type>
<input type=hidden name=j value=write>
<input type=hidden name=c value=0>
<input type=hidden name=bd value="$in{'bd'}">
<table width=$table_size border=0 cellspacing=0>
$td_66ccff $msg{'name'}
$td_ffffff<input name="id" type="text" size=10 maxlength=10>
$td_66ccff $msg{'passwd'}
$td_ffffff<input type=password name="passwd" type="text" size=10 maxlength=10>
$td_66ccff E-mail
$td_ffffff<input name="email" type="text" size=40 maxlength=40>
$file_up_ok
$td_66ccff $msg{'title'}
$td_ffffff<input name="title" type="text" size=40 maxlength=40>
<tr><td valign=top colspan=2>$font
<textarea name="content" rows=12 cols=$col_size></textarea>
<tr><td colspan=2 valign=bottom align=right>$font <font size=2>
<input type="reset" value="$msg{'undo'}"><INPUT type="submit" value="          $msg{'done'}          "></td>
</TABLE></FORM>
<p><a href="http://eleComm.electra.inha.ac.kr/eleComm" target=_top><img src="image/eleComm.gif" border=0></a>
END
}

sub FixForm{
	$td_ffffff="<td align=left width=580 bgcolor=#ffffff>";
	$td_66ccff="<tr><td align=center valign=middle width=70 bgcolor=#66ccff><font size=2>";

	$WOW_RECNO=new DB_File::RECNOINFO ;
	$WOW_RECNO->{'bval'}="\0";
	$db=tie @db_line,"DB_File",$data_file,O_RDONLY,0644,$WOW_RECNO or Err_Msg_Back("wowboard error:\\n$msg{'eOpen'}");

	($id,$passwd,$email,$title,$date,$weekday,$thetime,$count,$dcount,$content,$realname,$upname,$child,$thread)=split(/\t/,$db_line[$db->length-1-$in{'c'}]);

	$col_size=int($table_size/7);
	$font="<font face=\"gulimche,ü\">";

	print &PrintHead;
	print <<END;
<form action="$ENV{'SCRIPT_NAME'}" method="POST">
<input type=hidden name='fixed' value="1">
<input type=hidden name='c' value="$in{'c'}">
<input type=hidden name='j' value='write'>
<input type=hidden name='bd' value="$in{'bd'}">
<table width=$table_size border=0 cellspacing=0>
$td_66ccff $msg{'name'}
$td_ffffff<input name='id' type='text' size=9 maxlength=10 value="$id">
$td_66ccff $msg{'passwd'}
$td_ffffff<input type=password name="passwd" type="text" size=9 maxlength=9>
$td_66ccff E-mail
$td_ffffff<input name="email" type="text" size=40 maxlength=50 value="$email">
$td_66ccff $msg{'title'}
$td_ffffff<input name="title" type="text" size=40 maxlength=50 value="$title">
<tr><td valign=top colspan=2>$font<textarea name="content" rows=12 cols=$col_size>
$content
</textarea>
<tr><td colspan=2 valign=bottom align=right>$font <font size=2>
<input type="reset" value="$msg{'undo'}"><INPUT type="submit" value="          $msg{'done'}          "></td>
</TABLE></FORM>
<p><a href=\"http://eleComm.electra.inha.ac.kr/eleComm\"><img src=\"image/eleComm.gif\" border=0></a>
END
}

sub DeleteForm{
	$font="<font face=\"gulimche,ü\">";

	print &PrintHead;
	print <<END;
<form action=$ENV{'SCRIPT_NAME'} method=POST>
<input type=hidden name="j" value="delete_ok">
<input type=hidden name="delete" value="1">
<input type=hidden name="c" value="$in{'c'}">
<input type=hidden name="u" value="$in{'u'}">
<input type=hidden name="bd" value="$in{'bd'}">
<table width=200 height=120 border=0 cellspacing=0 align=center>
<th align=center height=20 bgcolor=red><font color=#ffffee size=2>$msg{'passwd'}
<tr><td align=center valign=middle height=40 bgcolor=#ffffff><input type=password name="passwd" type="text" size=9 maxlength=9>
<tr><td align=center>$font <font size=2>
<input type="reset" value="$msg{'undo'}"><INPUT type="submit" value="$msg{'done'}"></td>
</TABLE></FORM>
<p><a href="http://eleComm.electra.inha.ac.kr/eleComm"><img src="image/eleComm.gif" border=0></a>
END
}

sub ReplyForm{
	$td_ffffff="<td align=left width=580 bgcolor=#ffffff>";
	$td_66ccff="<tr><td align=center valign=middle width=70 bgcolor=#66ccff><font size=2>";

	$WOW_RECNO=new DB_File::RECNOINFO ;
	$WOW_RECNO->{'bval'}="\0";
	$db=tie @db_line,"DB_File",$data_file,O_RDONLY,0644,$WOW_RECNO or Err_Msg_Back("wowboard error:\\n$msg{'eOpen'}");
	($id,$passwd,$email,$title,$date,$weekday,$thetime,$count,$dcount,$content,$realname,$upname,$child,$thread)=split(/\t/,$db_line[$db->length-1-$in{'c'}]);

	$content=~s/\n/\n>/g;
	if($title!~/^/){$title=" $title";}
	$col_size=int($table_size/7);
	$font="<font face=\"gulimche,ü\">";
	$checked_mail=($email?'checked':'');

	print &PrintHead;
	print <<END;
<form action=$ENV{'SCRIPT_NAME'} method=POST>
<input type=hidden name="reply" value="1">
<input type=hidden name="c" value="$in{'c'}">
<input type=hidden name="u" value="$in{'u'}">
<input type=hidden name="j" value="write">
<input type=hidden name="bd" value="$in{'bd'}">
<table width=$table_size border=0 cellspacing=0>
$td_66ccff $msg{'name'}
$td_ffffff<input name="id" type="text" size=9 maxlength=10>
$td_66ccff $msg{'passwd'}
$td_ffffff<input type=password name="passwd" type="text" size=9 maxlength=9>
$td_66ccff E-mail
$td_ffffff<input name="email" type="text" size=40 maxlength=50>
$td_66ccff $msg{'title'}
$td_ffffff<input name="title" type="text" size=40 maxlength=50 value="$title">
<tr><td valign=top colspan=2>$font<textarea name="content" rows=12 cols=$col_size>
>$id wrote : 
>
>$content

</textarea>
<tr><td colspan=2 valign=bottom align=right>$font
<input $checked_mail type="checkbox" name="smail" value="yes"> $msg{'smail'}:
<input size=40 name="saddr" value="$email"><p>
<font size=2><input type="reset" value="$msg{'undo'}"><INPUT type="submit" value="          $msg{'done'}          "></td>
</TABLE></FORM>
<p><a href="http://eleComm.electra.inha.ac.kr/eleComm"><img src="image/eleComm.gif" border=0></a>
END
}

sub DeleteData{
	&LimitAccess;############

	$WOW_RECNO=new DB_File::RECNOINFO ;
	$WOW_RECNO->{'bval'}="\0";
	$db=tie @db_line,"DB_File",$data_file,O_RDWR,0666,$WOW_RECNO or Err_Msg_Back("wowboard error:\\n$msg{'eOpen'}");
	($id,$passwd,$email,$title,$date,$weekday,$thetime,$count,$dcount,$content,$realname,$upname,$child,$thread)=split(/\t/,$db_line[$db->length-1-$in{'c'}]);

	&Err_Msg_Back($msg{'undeletable'}) if($child);
	$ppasswd=crypt($in{'passwd'},substr($passwd,0,2));
	&Err_Msg_Back($msg{'ePasswd'}) if($passwd ne $ppasswd);

	$i=0;
	if($thread){
		while($i++<$in{'c'}){
			($uid,$upasswd,$uemail,$utitle,$udate,$uweekday,$uthetime,$ucount,$udcount,$ucontent,$urealname,$uupname,$uchild,$uthread)=split(/\t/,$db_line[$db->length-1-$in{'c'}+$i]);
			if($thread==$uthread+1){
				$uchild--;
				$db_line[$db->length-1-$in{'c'}+$i]=join('	',$uid,$upasswd,$uemail,$utitle,$udate,$uweekday,$uthetime,$ucount,$udcount,$ucontent,$urealname,$uupname,$uchild,$uthread);
				last;
			}
		}
	}
	unlink "$cfg{'upload_dir'}/$upname";
	$db->del($db->length-1-$in{'c'});
	&Refresh("?kw=$in{'kw'}&bd=".&UrlEncode($in{'bd'})."&c=$in{'u'}");
}

sub DataWrite{
	&LimitAccess;############

	local($db,@db_line,$id,$passwd,$email,$title,$date,$weekday,$thetime,$realname,$upname,$count,$dcount,$content,$child,$thread);
	$in{'id'}=~s/^[ \t]+//o;
	$in{'id'}=~s/[ \t]+/ /g;
	$in{'id'}=~s/</&lt\;/g;
	$in{'title'}=~s/^[ \t]+//o;
	$in{'title'}=~s/[ \t]+/ /g;
	$in{'title'}=~s/</&lt\;/g;
	$in{'email'}=~s/[ \t]+//g;
	$in{'email'}=~s/</&lt\;/g;
	$in{'content'}=~s/\t/        /g;

	$in{'id'}='մ' if ($in{'id'} eq '');
	&Err_Msg_Back($msg{'wTitle'}) if ($in{'title'} eq '');
	&Err_Msg_Back($msg{'wContent'}) if ($in{'content'} eq '');
	&Err_Msg_Back($msg{'wScript'}) if ($in{'content'} =~/<[sS][cC][rR][iI][pP][tT]/);

	local($sec,$min,$hour,$day,$mon,$year,$wday,@tmp)=localtime(time);
	$mon=$mon+1;

	$mon="0".$mon if($mon<10);
	$day="0".$day if($day<10);
	$hour="0".$hour if($hour<10);
	$min="0".$min if($min<10);

	$in{'content'}=~s/\r//g;

	&SendMail($in{'email'},$in{'saddr'},"$in{'id'}".($in{'email'}?"($in{'email'})":'').$msg{'sReply'},"$msg{'title'}: $in{'title'}\n\n$in{'content'}\n") if($in{'smail'} eq 'yes');

	if($in{'fixed'}){
		$WOW_RECNO=new DB_File::RECNOINFO ;
		$WOW_RECNO->{'bval'}="\0";
		$db=tie @db_line,"DB_File",$data_file,O_RDWR|O_CREAT,0666,$WOW_RECNO or Err_Msg_Back("wowboard error:\\n\\nDataWrite\\n$msg{'eOpen'}");
		($id,$passwd,$email,$title,$date,$weekday,$thetime,$count,$dcount,$content,$realname,$upname,$child,$thread)=split(/\t/,$db_line[$db->length-1-$in{'c'}]);
		$ppasswd=crypt($in{'passwd'},substr($passwd,0,2));
		($passwd eq $ppasswd) || &Err_Msg_Back($msg{'ePasswd'});

		$db_line[$db->length-1-$in{'c'}]="$in{'id'}	$passwd	$in{'email'}	$in{'title'}	$year/$mon/$day	$wday	$hour:$min:$sec	$count	$dcount	$in{'content'}	$realname	$upname	$child	$thread";
		&Refresh("?kw=".&UrlEncode($in{'kw'})."&bd=".&UrlEncode($in{'bd'}));
		exit;
	}
	if($in{'passwd'} ne ''){$in{'passwd'}=crypt($in{'passwd'},chr(rand(25)+65).chr(rand(25)+65));
	}else{ $in{'passwd'}='*';}

	$realname=$upname=$cgi_cfn{'upfile'};
	if($upname ne ''){
		$upname=~s/.+\\//g;
		$upname=~s/.+\///g;
		$upname=~s/\s/\_/g;
		$i=0;
		while(-e "$cfg{'upload_dir'}/$upname"){
			$i++;
			$upname="$i\_$upname";
		}
		if(open (SFILE, "< $cgi_sfn{'upfile'}")){
			if(open (FILE, "> $cfg{'upload_dir'}/$upname")){
				$buf="";
				binmode(SFILE);
				binmode(FILE);
				while(read(SFILE,$buf,8192)){
					print FILE $buf;
				}
				close(FILE);
				close(SFILE);
			}else{
				close(SFILE);
				unlink "$cgi_sfn{'upfile'}";
				&Err_Msg_Back($msg{'eSave'});
			}
		}else{
			unlink "$cgi_sfn{'upfile'}";
			&Err_Msg_Back($msg{'eRead'});
		}
	}
	unlink "$cgi_sfn{'upfile'}";
	$WOW_RECNO=new DB_File::RECNOINFO ;
	$WOW_RECNO->{'bval'}="\0";
	$db=tie @db_line,"DB_File",$data_file,O_RDWR|O_CREAT,0666,$WOW_RECNO or Err_Msg_Back("wowboard error:\\n\\nDataWrite\\n$msg{'eOpen'}");

	if($in{'reply'}){
		($id,$passwd,$email,$title,$date,$weekday,$thetime,$count,$dcount,$content,$realname,$upname,$child,$thread)=split(/\t/,$db_line[$db->length-1-$in{'c'}]);
		$child++;
		$db_line[$db->length-1-$in{'c'}]=join('	',$id,$passwd,$email,$title,$date,$weekday,$thetime,$count,$dcount,$content,$realname,$upname,$child,$thread);
		$thread++;
		$db->put($db->length-1-$in{'c'},"$in{'id'}	$in{'passwd'}	$in{'email'}	$in{'title'}	$year/$mon/$day	$wday	$hour:$min:$sec	0	0	$in{'content'}	$realname	$upname	0	$thread",R_IBEFORE);
	}else{
		$db->push("$in{'id'}	$in{'passwd'}	$in{'email'}	$in{'title'}	$year/$mon/$day	$wday	$hour:$min:$sec	0	0	$in{'content'}	$realname	$upname	0	0");
	}
	&Refresh("?kw=".&UrlEncode($in{'kw'})."&bd=".&UrlEncode($in{'bd'}));
}

sub ShowBoard{
	local($total_data,$fore,$back,$total_line,$fp,$bp,$undeletable=1);
	local(@nums,@id,@passwd,@email,@title,@date,@weekday,@thetime,@realname,@upname,@count,@dcount,@content,@child,@thread);

	&fetchIndex('board');

	local $print_str=&PrintHead;
	$print_str.=&print_table;
	if($cfg{'show_button'} ne 'none'){
		$print_str.=(($cfg{'show_button'} eq 'short')?&ShortButton("1",'board'):&Button("1",'board'));
	}
	print "$print_str\</body></html>";
}

sub print_table{
	return "<br>\n<font color=red><b>- $msg{'nodata'} -</b></font>" if ($total_line <= 0);
	local $return_str=&table_head;

	$td_top=" align=center><font size=2>";
	for ($i=0;($i<=$#nums)&&($i<$page);$i++){
		$id[$i]='Guest' if(($id[$i] eq 'մ')&&($cfg{'language'} ne 'kr'));######################
		$return_str.="<tr>\n";
		$return_str.="<td bgcolor=\"$cfg{'t_num_bcolor'}\"$td_top$nums[$i]</td>\n" if($cfg{'t_num_show'});
		$return_str.="<td bgcolor=\"$cfg{'t_file_bcolor'}\" align=center><font size=2>".(($upname[$i] ne '')?"<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'})."&j=dl&file=$upname[$i]&realname=$realname[i]\" $message'$upname[$i]'\;return true\;\"><img src=\"./image/file.gif\" border=0></a>":"&nbsp\;")."</td>\n" if($cfg{'t_file_show'});
		$return_str.="<td bgcolor=\"$cfg{'t_dcount_bcolor'}\"$td_top".($dcount[$i]>=100 ? '<font color=red>' : '')."$dcount[$i]</td>\n"  if($cfg{'t_dcount_show'});
		$return_str.="<td bgcolor=\"$cfg{'t_title_bcolor'}\" align=left><font size=2>".("&nbsp &nbsp " x $thread[$i])."<a href=\"$ENV{'SCRIPT_NAME'}?bd=".&UrlEncode($in{'bd'});
		$return_str.="&kw=$in{'kw'}&s_title=$in{'s_title'}&s_name=$in{'s_name'}&s_content=$in{'s_content'}" if($in{'kw'} ne '');
		$return_str.="&j=content&u=$in{'c'}&c=".($i+$in{'c'})."\" $message'".&check_nonchar($title[$i])."'\;return true\">$title[$i]</a></td>\n" if($cfg{'t_title_show'});
		$return_str.="<td bgcolor=\"$cfg{'t_count_bcolor'}\"$td_top".($count[$i]>=100 ? '<font color=red>' : '')."$count[$i]</td>\n"  if($cfg{'t_count_show'});
		$return_str.="<td bgcolor=\"$cfg{'t_date_bcolor'}\"$td_top".&cal_new($date[$i],$weekarray[$weekday[$i]])."</td>\n" if($cfg{'t_date_show'});
		$return_str.="<td bgcolor=\"$cfg{'t_name_bcolor'}\"$td_top".($email[$i]?"<a href=\"mailto:$email[$i]\">$id[$i]</a>":"$id[$i]")."</td>\n" if($cfg{'t_name_show'});
	}
	return "$return_str\</table></td></table>\n";
}

sub ShowContent{
	local($total_data,$fore,$back,$total_line,$fp,$bp);
	local(@nums,@id,@passwd,@email,@title,@date,@weekday,@thetime,@realname,@upname,@count,@dcount,@content,@child,@thread);
	local $print_str=&PrintHead;
	&fetchIndex('board');
	$print_str.=&print_content('board');
	if($cfg{'show_button'} ne 'none'){
		$print_str.=(($cfg{'show_button'} eq 'short')?&ShortButton("1",'board'):&Button("1",'board'));
	}
	print "$print_str\<p><a href=\"http://eleComm.electra.inha.ac.kr/eleComm\" target=_top><img src=\"image/eleComm.gif\" border=0 align=center></a></body></html>";
}
sub ViewUnsorted{
	$WOW_RECNO=new DB_File::RECNOINFO ;
	$WOW_RECNO->{'bval'}="\0";
	$db=tie @db_line,"DB_File",$data_file,O_CREAT|O_RDWR,0666,$WOW_RECNO or Err_Msg_Back("wowboard error:\\n\\nFetchIndex\\n$msg{'eOpen'}");
	print "Content-type: text/html\n\n<table width=900 cellspacing=1 border=1>";
	print "\n<td>".join('</td><td>','id','passwd','email','title','day','weekday','thetime','count','dcount','content','realname','upname','child','thread');
	for($i=0;$i<$db->length;$i++){
		($iid,$ppasswd,$eemail,$ttitle,$dday,$wweekday,$tthetime,$ccount,$ddcount,$ccontent,$rrealname,$uupname,$cchild,$tthread)=split(/\t/,$db_line[$i]);
		print "\n<tr>\n<td>".join('</td><td>',$iid,$ppasswd,$eemail,$ttitle,$dday,$wweekday,$tthetime,$ccount,$ddcount,$ccontent,$rrealname,$uupname,$cchild,$tthread);
		print '</td>';
	}
	print '</table>';
	exit;
}